summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorTom Barrett <tom@tombarrett.xyz>2023-04-23 21:17:31 +0200
committerTom Barrett <tom@tombarrett.xyz>2023-04-23 21:17:31 +0200
commit25f9b730dee4919019bef5b32deb2f4098edd520 (patch)
treebfcee9781b3ddf08bda080cd91b5567da2d44c88
parentd42be4aae613212561e8b0e608ca313be5d89330 (diff)
passmenu for otp
-rwxr-xr-xscripts/passotpmenu36
1 files changed, 36 insertions, 0 deletions
diff --git a/scripts/passotpmenu b/scripts/passotpmenu
new file mode 100755
index 0000000..0e1c834
--- /dev/null
+++ b/scripts/passotpmenu
@@ -0,0 +1,36 @@
+#!/usr/bin/env bash
+
+shopt -s nullglob globstar
+
+typeit=0
+if [[ $1 == "--type" ]]; then
+ typeit=1
+ shift
+fi
+
+if [[ -n $WAYLAND_DISPLAY ]]; then
+ dmenu=dmenu-wl
+ xdotool="ydotool type --file -"
+elif [[ -n $DISPLAY ]]; then
+ dmenu=dmenu
+ xdotool="xdotool type --clearmodifiers --file -"
+else
+ echo "Error: No Wayland or X11 display detected" >&2
+ exit 1
+fi
+
+prefix=${PASSWORD_STORE_DIR-~/.password-store}
+password_files=( "$prefix"/**/*.gpg )
+password_files=( "${password_files[@]#"$prefix"/}" )
+password_files=( "${password_files[@]%.gpg}" )
+for f in "${password_files[@]}"; do [[ $f == *"otp"* ]] && otp_files+=("$f"); done
+
+password=$(printf '%s\n' "${otp_files[@]}" | "$dmenu" "$@")
+
+[[ -n $password ]] || exit
+
+if [[ $typeit -eq 0 ]]; then
+ pass otp show -c "$password" 2>/dev/null
+else
+ pass otp show "$password" | { IFS= read -r pass; printf %s "$pass"; } | $xdotool
+fi